'
'  RAS Functions
'
'  Partial translation of the C header files for the RAS connection
'
'  by Don Dickinson
'  Hereby Public Domain
'  Use or Misuse of this code implies that you hold the author (Don Dickinson)
'  harmless for any effects or side-effects generated by this code.
'
'  Depends upon your copy of win32api.inc that came with PB/DLL
'
'=================================================================================================
%RASBASE = 600

%ERROR_INVALID_PORT_HANDLE             = %RASBASE + 1
%ERROR_BUFFER_TOO_SMALL                = %RASBASE + 3
%ERROR_BUFFER_INVALID                  = %RASBASE + 10
%ERROR_CANNOT_FIND_PHONEBOOK_ENTRY     = %RASBASE + 23
%ERROR_INVALID_SIZE                    = %RASBASE + 32

%RAS_MAXENTRYNAMEBUFFER = 257
%RAS_MAXDEVICETYPE      = 16
%RAS_MAXENTRYNAME       = 256
%RAS_MAXDEVICENAME      = 128
%RAS_MAXPHONENUMBER     = 128
%RAS_MAXCALLBACKNUMBER  = %RAS_MAXPHONENUMBER
%ULEN                   = 256
%PWLEN                  = 256
%DNLEN                  = 15

'- Connection Status Constants
%RASCS_PAUSED                 = &h1000
%RASCS_DONE                   = &h2000
%RASCS_Connected              = %RASCS_DONE

'- The members are not dword aligned, but the whole
'  structure has to fit into a 4-byte bounded memory space,
'  thus the extra 3-byte buffer at the end of the structure.
'  So far, all of the ras structures I've found work this
'  way. NOTE: This is not the same as using the Dword specifier
'  in the type declaration (that would dword align each
'  member of the structure).
'
Type RASENTRYNAME
   dwSize As Dword
   szEntryName As Asciiz * %RAS_MAXENTRYNAMEBUFFER
   buffer As Asciiz * 3
End Type

Type RASDIALPARAMS
   dwSize As Dword                                             '4
   szEntryName As Asciiz * %RAS_MAXENTRYNAME + 1               '257
   szPhoneNumber As Asciiz * %RAS_MAXPHONENUMBER + 1           '129
   szCallBackNumber As Asciiz * %RAS_MAXCALLBACKNUMBER + 1     '129
   szUserName As Asciiz * %ULEN + 1                            '257
   szPassword As Asciiz * %PWLEN + 1                           '257
   szDomain As Asciiz * %DNLEN + 1                             '16
   buffer As String * 3                                        '3
End Type

Type RASDIALEXTENSIONS
   dwSize As Dword
   dwfOptions As Dword
   hwndParent As Long
   reserved As Long
End Type

Type RASCONN
   dwSize As Dword                                       '4
   hRasConn As Long                                      '4          8
   szEntryName As Asciiz * %RAS_MAXENTRYNAME + 1         '257        265
   szDeviceType As Asciiz * %RAS_MAXDEVICETYPE + 1       '17         282
   szDeviceName As Asciiz * %RAS_MAXDEVICENAME + 1       '129        411
   buffer As String * 1                                  '1          412
End Type

Type RASCONNSTATUS
    dwSize As Dword                                      '4
    rasconnstate As Long                                 '4    8
    dwError As Dword                                     '4    12
    szDeviceType As Asciiz * %RAS_MAXDEVICETYPE + 1      '17   29
    szDeviceName As Asciiz * %RAS_MAXDEVICENAME + 1      '129  158
    buffer As String * 2                                 '1    160
End Type

'- Finally, the functions
Declare Function RasGetConnectStatus Lib "rasapi32.dll" Alias "RasGetConnectStatusA" _
      (  ByVal hRasConn As Long, lpRasConnStatus As RASCONNSTATUS ) As Long

Declare Function RasEnumEntries Lib "rasapi32.dll" Alias "RasEnumEntriesA" _
      (  zReserved As Asciiz, zPhoneBook As Asciiz, lpRasEntry As RASENTRYNAME, _
         lpCb As Long, lpcEntries As Long ) As Long

Declare Function RasGetEntryDialParams Lib "rasapi32.dll" Alias "RasGetEntryDialParamsA" _
      (  zPhoneBook As Asciiz, rDialParams As RASDIALPARAMS, iPassword As Long ) As Long

Declare Function RasDial Lib "rasapi32.dll" Alias "RasDialA" _
      (  lpRasDialExtensions As RASDIALEXTENSIONS, lpszPhoneBook As Asciiz, _
         lpRasDialParams As RASDIALPARAMS, ByVal dwNotiferType As Dword, _
         ByVal lpvNotifier As Long, lphRasConn As Long   ) As Dword

Declare Function RasHangUp Lib "rasapi32.dll" Alias "RasHangUpA" _
      (  ByVal hRasConn As Long ) As Long

Declare Function RasEnumConnections Lib "rasapi32.dll" Alias "RasEnumConnectionsA" _
      (  lpRasConn As RASCONN, lpcb As Long, lpcConnections As Long ) As Dword
