'
'  rastest2.bas
'
'  Ras Test Program
'  PB/CC program that displays active RAS connections 
'  and prompts the user to disconnect one.
'
$DIM ALL

'- We have a choice of using the ras32.dll to
'  handle ras or compiling right into our exe
'
%COMPILE_WITH_DLL = 1
$IF %COMPILE_WITH_DLL
   %True = -1
   %False = 0
   $INCLUDE "rs32.inc"
$ELSE
   $INCLUDE "win32api.inc"
   $INCLUDE "ras_wrap.bas"
$ENDIF

Function PbMain()

   Dim i As Long
   Dim iConnections As Long
   Dim iSelect As Long
   Dim hRas As Long
   Dim sSelect As String
   Dim ky as String

   '- Get the number of active RAS connections
   iConnections = rsActiveConnections
   If iConnections < 1 Then
      stdout "No active RAS connections found"
   Else

      '- Print them on the screen and let the user select one.
      stdout  "Found" + Str$(iConnections) + " connections."
      For i = 1 To iConnections
          stdout Format$(i) + ". " + Trim$(rsGetConnectionName(i))
      Next i
      stdout  "Type in the number of the connection to terminate press enter: ";
      StdIn Line sSelect
      iSelect = Int(Val(sSelect))

      '- Invalid selection means we quit
      If (iSelect < 1) Or (iSelect > iConnections) Then
         stdout  "No connection terminated."
      Else

         stdout "Disconnecting " + Trim$(rsGetConnectionName(iSelect)) + "..."

         '- Hangup
         hRas = rsGetConnectionHandle(iSelect)
         If hRas = %False Then
            stdout  "Unable to obtain connection handle."
         Else
            rsHangupConnection hRas
            stdout  "Connection Terminated."
         End If
      End If
   End If

End Function
